# Dəniz döyüşü

Andrey bu yaxınlarda Çex Hərbi Dəniz Qüvvələrinin böyük admiralı rütbəsinə yüksəldi. Lakin, o, nəhayət ki, təhlükəsiz bir işi olduğunu düşünməyə başladıqda, hökumət dəniz donanmasının ləğvi də daxil olmaqla, hərbi büdcənin azaldılmasını elan etdi.

Ona görə də Andrey hökumətə Çex Hərbi Dəniz Qüvvələrinin nə qədər vacib olduğunu göstərməyə qərar verdi.
O, casuslarından dörd böyük donanmanın qarşıdan gələn dəniz döyüşü haqqında məlumat alır. Əgər o, qalib gələ bilsəydi, bu, şübhəsiz ki, kifayət qədər nümayişkaranə olardı.

Təəssüf ki, Çex Hərbi Dəniz Qüvvələrinin nə döyüş gəmiləri, nə də dəniz limanları var. Ancaq Andreyin casusları bəzi gəmiləri ələ keçirsəydilər, onun şansı ola bilərdi. Kaş ki, hansı gəmilərin döyüşdən sağ çıxacağını bilə bilsəydi...

Dəniz döyüşü belə baş verir: Başlanğıcda $i$-ci gəmi $(x_i, y_i)$ xanasında başlayır. Burada $x_i$ və $y_i$ cüt ədədlərdir. Bundan əlavə, gəmi dörd donanmadan birinə aiddir: Şimal, Cənub, Şərq və ya Qərb donanması.
Sonra döyüş mərhələli şəkildə davam edir. Hər bir mərhələdə:
- Öncə hər bir gəmi eyni vaxtda öz donanmasına uyğun istiqamətdə bir xana hərəkət edir.
- İndi iki və ya daha çox gəmi eyni xanadadırlarsa, onlar batır və xəritədən yox olurlar.

Artıq heç bir toqquşma mümkün deyilsə döyüş başa çatır.  _Sağ qalan gəmi_ döyüş bitdikdən sonra xəritədə qalan gəmidir.

Gəmi öz donanmasının istiqamətinə uyğun hərəkət edir.
Hər istiqamətdə hərəkət onun koordinatlarını aşağıdakı kimi dəyişir:
- Şimal — $y$ koordinatını 1 azaldır
- Cənub — $y$ koordinatını 1 artırır
- Şərq — $x$ koordinatını 1 artırır
- Qərb — $x$ koordinatını 1 azaldır


## Giriş verilənləri
Birinci sətirdə bir tam ədəd, $N$, gəmilərin sayı verilir. Daha sonra hər birində boşluqla ayrılmış $x_i$, $y_i$ və $d_i$ olan $N$ sətir verilir. $x_i$ və $y_i$ tam ədədləri $i$-ci gəminin koordinatlarıdır. $d_i$ `N`, `S`, `E` və ya `W` simvollarından biridir və $i$-ci gəminin donanmasının istiqamətini təsvir edir.

Başlanğıcda koordinatları eyni olan hər hansı iki gəmi yoxdur. 
Yəni ki, hər hansı $i$ və $j$ ($i \neq j$) gəmiləri üçün ya $x_i \neq x_j$ ya da $y_i \neq y_j$.


## Çıxış verilənləri

_Sağ qalan hər bir gəmi_ üçün yeni sətirdən onun nömrəsini göstərən $i$ ($1 \leq i \leq N$) tam ədədini çap edin.
_Sağ qalan gəmilərin_ nömrələrini istənilən sıra ilə çıxışa verə bilərsiniz. 

_Sağ qalan gəmi_ yoxdursa, çıxış boş olmalıdır.


## Nümunələr

### Nümunə 1
Giriş:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Çıxış:
```
7
```

Döyüş əvvəlcə belə görünür:
![](battle-sample1-v2.svg)

Və sonra aşağıdakı kimi davam edir:
- 2-ci mərhələ zamanı 3 və 4 nömrəli gəmilər $(4, 4)$ xanasında toqquşur.
- 6-cı mərhələ zamanı 1 və 5 nömrəli gəmilər $(6, 6)$ xanasında toqquşur. 
Eyni zamanda 2 və 6 nömrəli gəmilər $(6, 8)$ xanasında toqquşur.
Yeganə _sağ qalan gəmi_ 7 nömrəli gəmidir.

### Nümunə 2
Giriş:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Çıxış:
```
5
2
```
![](battle-sample2.svg)

İkinci mərhələ zamanı 1, 3 və 4 nömrəli gəmilər $(2, 4)$ xanasında toqquşacaq. 2 və 5 nömrəli gəmilər sağ qalacaq.


## Məhdudiyyətlər
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ ($1 \leq i \leq N$ olan hər bir $i$ üçün) və $x_i, y_i$ cüt ədədlərdir.

## Alt tapşırıqlar
1. (6 bal) $N = 2$
2. (12 bal) $N \leq 100$, $x_i, y_i \leq 100$ ($1 \leq i \leq N$ olan hər bir $i$ üçün)
3. (8 bal) $N \leq 100$, $x_i, y_i \leq 10^5$ ($1 \leq i \leq N$ olan hər bir $i$ üçün)
4. (11 bal) $N \leq 200$
5. (9 bal) $N \leq 5\,000$
6. (30 bal) $d_i$ ya `S` ya da `E`-dir ($1 \leq i \leq N$ olan hər bir $i$ üçün)
7. (24 bal) _əlavə məhdudiyyət yoxdur_