# Námořní bitva

Ondra byl nedávno povýšen na nejvyššího admirála české flotily.  Myslel si, že tím má zajištěnou budoucnost; ale krátce poté vláda v rámci úsporných opatření oznámila zrušení flotily. Aby tomu předešel, Ondra se rozhodl předvést vládě, jak důležitá a významná česká flotila je. Od zvědů ví, že se blíží námořní bitva čtyř flotil.  Kdyby ji vyhrál, určitě by to stačilo!

Česká flotila bohužel nemá žádné lodě ani přístavy. Kdyby ale Ondrovi zvědi takticky obsadili několik nepřátelských lodí, mohl by přesto mít šanci. Jen kdyby věděl, které lodě bitvu přežijí…

Námořní bitva probíhá následovně: Loď $i$ začne bitvu na zadaném čtverečku
$(x_i, y_i)$, kde $x_i$ i $y_i$ jsou sudá celá čísla. Každá loď patří do jedné z flotil: Severní (označené písmenem `N`), Jižní (písmeno `S`), Východní (písmeno `E`), či Západní (písmeno `W`).  Bitva probíhá v tazích, v každém z nich se
- nejprve všechny lodě naráz posunou o jeden čtvereček ve směru určeném názvem flotily a
- poté, jestliže se na libovolném čtverečku nacházejí dvě či více lodí, všechny se srazí, potopí a zmizí z mapy.

Přesněji řečeno, lodě každé flotily mění v první části tahu svoje souřadnice následujícím způsobem:
- Severní N — souřadnice $y$ se zmenší o 1
- Jižní S — souřadnice $y$ se zvětší o 1
- Východní E — souřadnice $x$ se zvětší o 1
- Západní W — souřadnice $x$ se zmenší o 1

Bitva konči, když už nejsou možné žádné další srážky lodí. Loď *přežije bitvu*, jestliže se dle popsaných pravidel nepotopí, nikdy tedy během bitvy nesdílí čtvereček s jinou lodí.

## Vstup
První řádka vstupu obsahuje kladné celé číslo $N$. Následuje $N$ řádek, z nichž $i$-tá obsahuje nezáporná celá sudá čísla $x_i$ a $y_i$ a znak $d_i$, odělené mezerami. Čísla $x_i$ a $y_i$ jsou počáteční souřadnice $i$-té lodě.
Znak $d_i$ je `N`, `S`, `E`, nebo `W` a udává písmeno flotily, do níž $i$-tá loď patří, a tedy i směr, kterým se bude pohybovat.

Počáteční souřadnice všech lodí jsou různé, tj. pro každé dvě lodě $i$ a $j$ ($i \neq j$) platí $x_i \neq x_j$ nebo $y_i \neq y_j$.

## Výstup
Vypište čísla lodí, které přežijí bitvu (lodě jsou číslovány od $1$ do $N$ dle pořadí na vstupu). Každé z čísel vypište na samostatnou řádku, pořadí vypsaných čísel může být libovolné. Jestliže žádná loď nepřežije bitvu, výstup by měl být prázdný.

## Příklady

### Příklad 1
Vstup:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Výstup:
```
7
```

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

Počáteční stav bitvy je následující:
![](battle-sample1-v2.svg)

Bitva probíhá následujícím způsobem:
- Ve druhém tahu se lodě 3 a 4 srazí na čtverečku $(4, 4)$.
- V šestém tahu se lodě 1 a 5 srazí na čtverečku $(6, 6)$ a zároveň se lodě 2 a 6 srazí na čtverečku $(6, 8)$.
Bitvu přežije pouze loď 7.

### Příklad 2
Vstup:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Výstup:
```
5
2
```
![](battle-sample2.svg)

Ve druhém tahu se lodě 1, 3 a 4 srazí na čtverečku $(2, 4)$. Lodě 2 a 5 bitvu přežijí.

## Omezení na vstupy
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ a $x_i, y_i$ jsou sudá pro každé $i$ tž. $1 \leq i \leq N$.

## Podúlohy
1. (6 bodů) $N = 2$
2. (12 bodů) $N \leq 100$, $x_i, y_i \leq 100$ pro každé $i$ tž. $1 \leq i \leq N$
3. (8 bodů) $N \leq 100$, $x_i, y_i \leq 10^5$ pro každé $i$ tž. $1 \leq i \leq N$
4. (11 bodů) $N \leq 200$
5. (9 bodů) $N \leq 5\,000$
6. (30 bodů) $d_i$ je buď `S` nebo `E` pro každé $i$ tž. $1 \leq i \leq N$
7. (24 bodů) _bez dalších předpokladů_
