# Seeschlacht
Ondra wurde kürzlich zum Grand Admiral der Tschechischen Marine ernannt. Kurz nachdem er sich in seinen neuen Job eingelebt hatte, wurde aufgrund von Budgetkürzungen der Regierung die komplette Auflösung der Marine angekündigt. 

Um dem entgegenzuwirken, möchte Ondra der Regierung zeigen, wie wichtig die Marine ist.
Durch seine Spione weiss er von einer bevorstehenden Seeschlacht von 4 grossen feindlichen Flotten. Gewinnt aber er - Ondra - diese Schlacht, würde dies die Regierung sicherlich umstimmen.

Leider verfügt die Tschechische Marine weder über Kriegschiffe, noch über Häfen. Aber wenn seine Spione einige Schiffe der Anderen übernehmen könnten, hätte er eine Chance. Wenn er nur wüsste, welche Schiffe die Schlacht überleben werden...

Eine Seeschlacht läuft wie folgt ab: Zu Beginn befindet sich Schiff $i$ an der Position $(x_i, y_i)$, wobei $x_i$ und $y_i$ gerade Zahlen sind. Jedes Schiff gehört einer von 4 Flotten an: Nördliche, Südliche, Östliche, Westliche.  
Dann läuft die Schlacht in Runden ab. In jeder Runde passiert folgendes:
- Zuerst bewegt sich jedes Schiff gleichzeitig um ein Feld in die jeweilige Richtung seiner Flotte.
- Wenn sich anschliessend zwei oder mehr Schiffe auf demselben Feld befinden, sinken diese und verschwinden von der Karte.

Die Richtung jedes Schiffs wird durch den Namen seiner Flotte bestimmt.  
Die Bewegung in eine Richtung verändert die Koordinaten nach dem folgenden Prinzip:
- Nördliche - verringert die $y$ Koordinate um 1
- Südliche - vergrössert die $y$ Koordinate um 1
- Östliche - vergrössert die $x$ Koordinate um 1
- Westliche - verringert die $x$ Koordinate um 1

Ein *überlebendes Schiff* ist ein Schiff welches niemals auf demselben Feld wie ein anderes Schiff gestanden ist.

## Eingabe
Die erste Zeile der Eingabe enthält eine Zahl $N$. Dann folgen $N$ Zeilen, jede davon enthält $x_i$, $y_i$, und $d_i$ welche durch Leerzeichen getrennt sind. Die Zahlen $x_i$ und $y_i$ sind die Koordinaten des $i$-ten Schiffs. Der Buchstabe $d_i$ ist entweder `N`, `S`, `E` oder `W` je nach Richtung des $i$-ten Schiffs. 

Keine zwei Schiffe befinden sich an denselben Koordinaten. Das bedeutet, für Schiff $i$ und $j$ ($i \neq j$) gilt $x_i \neq x_j$ und/oder $y_i \neq y_j$.

## Ausgabe
Für jedes überlebende Schiff, soll eine Zeile, welche eine Zahl $i$ ($1 \leq i \leq N$) enthält --- die Nummer des Schiffs, ausgegeben werden. Die Reihenfolge der Zeilen ist dabei egal.

Sollte es keine überlebenden Schiffe geben, soll nichts ausgegeben werden.

## Beispiele

### Beispiel 1
Eingabe:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Ausgabe:
```
7
```

Zu Anfangs sieht die Schlacht folgendermassen aus:
![](battle-sample1-v2.svg)

Dannach läuft die Schlacht folgendermassen ab:
- Nach Runde 2, kollidieren Schiff 3 und 4 an den Koordinaten $(4, 4)$.
- Nach Runde 6, kollidieren Schiff 1 und 5 an den Koordinaten $(6, 6)$.  
Gleichzeitig kollidieren Schiff 2 und 6 an den Koordinaten $(6, 8)$.  
Das einzige überlebenden Schiff ist das Schiff mit der Nummer 7.

### Beispiel 2
Eingabe:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Ausgabe:
```
5
2
```
![](battle-sample2.svg)

Nach der zweiten Runde, kollidieren Schiff 1, 3 und 4 an den Koordinaten $(2, 4)$. Schiff 2 und 5 überleben.

## Beschränkungen
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (für jedes $i$ mit $1 \leq i \leq N$) und $x_i, y_i$ sind gerade Zahlen.

## Teilaufgaben
1. (6 Punkte) $N = 2$
2. (12 Punkte) $N \leq 100$, $x_i, y_i \leq 100$ (für jedes $i$ mit $1 \leq i \leq N$)
3. (8 Punkte) $N \leq 100$, $x_i, y_i \leq 10^5$ (für jedes $i$ mit $1 \leq i \leq N$)
4. (11 Punkte) $N \leq 200$
5. (9 Punkte) $N \leq 5\,000$
6. (30 Punkte) $d_i$ ist entweder `S` oder `E` (für jedes $i$ mit $1 \leq i \leq N$)
7. (24 Punkte) _Keine zusätzlichen Beschränkungen_