# קרב ימי

אונדרה קודם לאחרונה לדרגת גרנד-אדמירל בחיל הים הצ'כי.
אבל, כשסוף סוף הוא התחיל לחשוב שהגיע לבטחון תעסוקתי,
הממשלה הכריזה על קיצוצי תקציב הכוללים פירוק של חיל הים.

אז אונדרה החליט להראות לממשלה עד כמה חיל הים הצ'כי חשוב.
הוא יודע דרך מרגליו על קרב ימי שיתרחש בקרוב בין ארבעת הציים הגדולים.
אם יוכל לנצח בו, זו בוודאות תהיה המחשה מספקת.

למרבה הצער, לחיל הים הצ'כי אין ספינות קרב ואין נמלים ימיים. אך אם
המרגלים של אונדרה יפילו כמה ספינות עשוי להיות לו סיכוי.
לו רק היה יודע אילו ספינות ישרדו את הקרב…

קרב ימי מתרחש כדלקמן: תחילה הספינה $i$ מתחילה במשבצת
$(x_i, y_i)$, כאשר גם $x_i$ וגם $y_i$ זוגיים. בנוסף,
הספינה שייכת לאחד מבין ארבעת הציים: הצפוני, הדרומי, המזרחי או המערבי.
לאחר מכן הקרב ממשיך בשלבים. בכל שלב:
- תחילה, כל ספינה זזה בו זמנית משבצת אחת בכיוון המתאים לצי שלה.
- אם שתי ספינות או יותר תופסות כעת את אותה המשבצת, הן שוקעות ונעלמות מהמפה.

הקרב מסתיים כאשר לא נשארות עוד התנגשויות אפשריות. _ספינה שורדת_ מוגדרת להיות ספינה אשר נשארה על המפה לאחר סוף הקרב.

ספינה זזה בהתאם לכיוון של הצי שלה. התנועה בכל כיוון משנה את הקואורדינטות כדלקמן:
- צפוני — מקטינה את שיעור ה-$y$ ב-1
- דרומי — מגדילה את שיעור ה-$y$ ב-1
- מזרחי — מגדילה את שיעור ה-$x$ ב-1
- מערבי — מקטינה את שיעור ה-$x$ ב-1

## קלט
שורת הקלט הראשונה מכילה את המספר השלם $N$. לאחר מכן יהיו $N$ שורות, כל אחת
מכילה את $x_i$, $y_i$, ו-$d_i$, מופרדים על ידי רווחים. המספרים השלמים $x_i$ ו-$y_i$ הם קואורדינטות הספינה ה-$i$.
התו $d_i$ הוא `N`, `S`, `E` או `W`, מתאר את הכיוון של הצי של הספינה ה-$i$.

לא יהיו שתי ספינות המתחילות עם אותן הקואורדינטות.
כלומר, עבור ספינות $i$ ו-$j$ ($i \neq j$) או שמתקיים $x_i \neq x_j$ או שמתקיים $y_i \neq y_j$.

## פלט
לכל _ספינה שורדת_, הדפיסו שורה אחת המכילה את המספר השלם
$i$ ($1 \leq i \leq N$) — המספר של הספינה.
אתם יכולים להדפיס את מספרי _הספינות השורדות_ בכל סדר.

אם אין _ספינות שורדות_, על הפלט להיות ריק.

## דוגמאות

### דוגמה 1
קלט:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
פלט:
```
7
```

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

הקרב תחילה נראה כך:
![](battle-sample1-v2.svg)

ולאחר מכן הוא ממשיך כדלקמן:
- במהלך שלב 2, הספינות 3 ו-4 יתנגשו ב-$(4, 4)$.
- במהלך שלב 6, הספינות 1 ו-5 יתנגשו ב-$(6, 6)$.
  באותו הזמן 2 ו-6 יתנגשו ב-$(6, 8)$.
_הספינה השורדת_ היחידה תהיה ספינה מספר 7.

### דוגמה 2
קלט:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
פלט:
```
5
2
```
![](battle-sample2.svg)

במהלך השלב השני, הספינות 1, 3 ו-4 יתנגשו ב-$(2, 4)$. הספינות 2 ו-5 ישרדו.

## מגבלות
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (לכל $i$ המקיים $1 \leq i \leq N$) וגם $x_i, y_i$ זוגיים.

## תתי משימות
1. (6 נקודות) $N = 2$
2. (12 נקודות) $N \leq 100$, $x_i, y_i \leq 100$ (לכל $i$ המקיים $1 \leq i \leq N$)
3. (8 נקודות) $N \leq 100$, $x_i, y_i \leq 10^5$ (לכל $i$ המקיים $1 \leq i \leq N$)
4. (11 נקודות) $N \leq 200$
5. (9 נקודות) $N \leq 5\,000$
6. (30 נקודות) $d_i$ הוא או `S` או `E` (לכל $i$ המקיים $1 \leq i \leq N$)
7. (24 נקודות) _ללא מגבלות נוספות_






