# Pomorska bitka

Ondra je nedavno promaknut u Velikog admirala Češke mornarice.
Slično kao što to bude i kod nas, pomislio je da će ga takav državni posao osigurati do kraja života.
Međutim, na svačije iznenađenje, vlada je najavila smanjenje proračuna uključujući raspuštanje mornarice.

Potaknut željom da dobiva plaću za obavljanje nepostojećeg posla, Ondra je odlučio pokazati vladi koliko je Češka mornarica stvarno važna. On je od svojih špijuna saznao za nadolazeću pomorsku bitku četiri velike flote. Kada bi uspio pobijediti u toj bitci i na brodovima podignuti prikladne zastave to bi zasigurno bila dovoljna demonstracija.

Na njegovu žalost, Češka mornarica nema ni ratne brodove ni morske luke, ali ako
Ondrini špijuni preuzmu neke brodove, možda ima šanse. Kad bi barem znao koji će brodovi preživjeti bitku...

Pomorska bitka odvija se na sljedeći način: U početku brod $i$ počinje na kvadratu
$(x_i, y_i)$, gdje su i $x_i$ i $y_i$ parni. Dodatno, svaki brod pripada jednoj od četiri flote: Sjevernoj, Južnoj, Istočnoj ili Zapadnoj.
Bitka se zatim odvija u koracima. U svakom koraku:
- Prvo, svaki brod istovremeno se pomiče za jedan kvadrat u smjeru koji odgovara njegovoj floti.
- Ako se dva ili više brodova sada nalaze u istom kvadratu, oni potonu i nestaju s karte.

Kretanje brodova je određeno time kojoj floti pripada. 
Kretanje u svakom smjeru mijenja koordinate na sljedeći način:
- Sjever — smanjuje koordinatu $y$ za 1
- Jug — povećava koordinatu $y$ za 1
- Istok — povećava koordinatu $x$ za 1
- Zapad — smanjuje koordinatu $x$ za 1

Za brod kažemo da je preživio ako u niti jednom trenutku nije dijelio kvadrat s nekim drugim brodom.

## Ulazni podatci
Prva linija ulaza sadrži cijeli broj $N$. Zatim slijedi $N$ linija, svaka
sadrži $x_i$, $y_i$ i $d_i$, odvojene razmacima. Cijeli brojevi $x_i$ i $y_i$ predstavljaju koordinate $i$-tog broda dok je
$d_i$ jedan od znakova: `N`, `S`, `E` ili `W`, opisujući flotu $i$-tog broda.

Nijedna dva broda u početku nemaju iste koordinate.
Drugim riječima, za brodove $i$ i $j$ ($i \neq j$) vrijedi ili $x_i \neq x_j$ ili $y_i \neq y_j$.

## Izlazni podatci
Za svaki preživjeli brod, ispišite jedan redak koji sadrži cijeli broj $i$ ($1 \leq i \leq N$) — indeks preživjelog broda.
Indekse preživjelih brodova možete ispisati u bilo kojem poretku.

Ako nema preživjelih brodova, izlaz treba biti prazan.

## Probni primjeri

### Primjer 1
Ulaz:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Izlaz:
```
7
```

Bitka će u početku izgledati ovako:
![](battle-sample1-v2.svg)

Zatim se odvija na sljedeći način:
- Nakon 2. poteza, brodovi 3 i 4 će se sudariti na $(4, 4)$.
- Nakon 6. poteza, brodovi 1 i 5 će se sudariti na $(6, 6)$.
  Istovremeno će se 2 i 6 sudariti na $(6, 8)$.
Jedini preživjeli brod će biti brod s indeksom 7.

### Primjer 2
Ulaz:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Izlaz:
```
5
2
```
![](battle-sample2.svg)

Nakon drugog poteza, brodovi 1, 3 i 4 će se sudariti na $(2, 4)$. Brodovi 2 i 5 će preživjeti.

## Ograničenja
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (za svaki $i$ takav da $1 \leq i \leq N$) i $x_i, y_i$ su parni.

## Bodovanje
1. (6 bodova) $N = 2$
2. (12 bodova) $N \leq 100$, $x_i, y_i \leq 100$ (za svaki $i$ takav da $1 \leq i \leq N$)
3. (8 bodova) $N \leq 100$, $x_i, y_i \leq 10^5$ (za svaki $i$ takav da $1 \leq i \leq N$)
4. (11 bodova) $N \leq 200$
5. (9 bodova) $N \leq 5\,000$
6. (30 bodova) $d_i$ je ili `S` ili `E` (za svaki $i$ takav da $1 \leq i \leq N$)
7. (24 bodova) _bez dodatnih ograničenja_
