# Tengeri csata

Ondrát nemrégiben a Cseh Haditengerészet legfőbb vezetőjévé, admirálissá léptették elő.
Amikor elkezdett gondolkodni, hogy végre biztos állása van, a kormány költségvetési megszorításokat jelentett be, beleértve a haditengerészet feloszlatását is.

Ondra úgy döntött, hogy megmutatja a kormánynak, mennyire fontos a Cseh Haditengerészet.
Kémei révén tud a négy nagy flotta közelgő tengeri csatájáról.
Ha a csatát meg tudná nyerni, az biztosan elég nagy demonstráció lenne a flotta szükségességére.

Sajnos, a Cseh Haditengerészetnek sem hadihajói, sem tengeri kikötői nincsenek. De ha Ondra kémei átvennének néhány hajót, talán lenne esélye. Bárcsak tudná, mely hajók élik túl a csatát...

A tengeri csata a következőképpen zajlik: 
Kezdetben az $i$. hajó az $(x_i, y_i)$ koordinátájú négyzeten áll, ahol $x_i$ és $y_i$ is páros. 
Minden hajó a négy flotta egyikéhez tartozik: az északra (N), a délre (S), a keletre (E) vagy a nyugatra (W) tartó flottához.
Ezután a csata lépésekben zajlik. Minden lépésben:
- Először minden hajó egyszerre egy mezőt mozog a flotta nevének megfelelő irányba.
- Ha két vagy több hajó a mozgás után ugyanazt a négyzetet foglalja el, akkor mindketten elsüllyednek és eltűnnek a térképről.

A csata akkor ér véget, amikor már nem lehet többé összeütközés.
A _túlélő hajó_ olyan hajó, amely a csata befejezése után is a térképen marad, azaz nem süllyedt el.

A hajó mindig a flotta nevében meghatározott irányba mozog.
Az egyes irányokba történő mozgás a következőképpen változtatja a hajó saját koordinátáit:
- N - észak - az $y$ koordináta 1 értékkel csökken.
- S - dél -  az $y$ koordináta 1-gyel növekszik.
- E - kelet - az $x$ koordináta 1-gyel növekszik.
- W - nyugat - az $x$ koordináta 1-gyel csökken.

## Bemenet
A bemenet első sora az $N$ egész számot tartalmazza. 

A következő $N$ sor mindegyike egy-egy $x_i$, $y_i$ és $d_i$ értékeket tartalmaz, szóközökkel elválasztva. Az $x_i$ és $y_i$ egész számok az $i$-edik hajó négyzetének a koordinátái.
A $d_i$ karakter értéke `N`, `S`, `E` vagy `W`, ami az $i$-edik hajó flottáját (és mozgásirányát) jelenti.

Kezdetben nincs két azonos koordinátájú hajó. Vagyis minden $i$ és $j$ hajópár esetén (ahol $i \neq j$):  $x_i \neq x_j$ vagy $y_i \neq y_j$.

## Kimenet
Minden egyes _túlélő hajó_ esetén új sorba kerüljön a hajó sorszámát jelentő  egész szám: $i$ (ahol $1 \leq i \leq N$).

A _túlélő hajók_ sorszámait tetszőleges sorrendben irathatod ki.

Ha nincs _túlélő hajó_, a kimenet legyen üres.

## Példák

### 1. példa
Bemenet:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Kimenet:
```
7
```
<br><br><br><br><br><br><br><br><br><br><br><br>
A csata kezdetben így néz ki:
![](battle-sample1-v2.svg)

Ezután a következőképpen folytatódik:
- A 2. lépésben a 3. és 4. hajó a $(4, 4)$ ponton ütközik.
- A 6. lépésben az 1. és az 5. hajó a $(6, 6)$ ponton ütközik. Ugyanekkor a 2. és a 6. hajó a $(6, 8)$ ponton ütközik.

Az egyetlen túlélő hajó a 7-es lesz.

### 2. példa
Bemenet:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Kimenet:
```
5
2
```
![](battle-sample2.svg)

A második lépésben az 1., 3. és 4. hajó a $(2, 4)$ ponton ütközik.

A 2. és az 5. hajó túléli a csatát.

## Korlátok
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (minden $i$-re, amire $1 \leq i \leq N$) és $x_i, y_i$ páros.

## Részfeladatok
1. (6 pont) $N = 2$
2. (12 pont) $N \leq 100$, $x_i, y_i \leq 100$ (minden $i$-re, amire $1 \leq i \leq N$)
3. (8 pont) $N \leq 100$, $x_i, y_i \leq 10^5$ (minden $i$-re, amire $1 \leq i \leq N$)
4. (11 pont) $N \leq 200$
5. (9 pont) $N \leq 5\,000$
6. (30 pont) $d_i$ vagy `S` vagy `E` (minden $i$-re, amire $1 \leq i \leq N$)
7. (24 pont) _nincs további megkötés_
