# Bitwa morska

Ondra awansował na admirała Czeskiej Marynarki Wojennej.
Niestety, okazało się, że nie jest to pewna posada.
Rząd właśnie ogłosił cięcia budżetowe i rozwiązanie całej floty.

Ondra postanowił udowodnić rządzącym, że Czeska Marynarka Wojenna jest ważna i potrzebna.
Od swoich szpiegów dowiedział się o nadchodzącej bitwie morskiej.
Jeśliby ją wygrał, osiągnąłby swój cel!

Niestety, Czechy nie mają ani statków, ani portów morskich.
Mimo to nie wszystko stracone!
Szpiedzy Ondry mogą przejąć cudze statki.
Ale które z nich przejąć?
Gdybyśmy tylko wiedzieli, które przetrwają bitwę...

Bitwy morskie odbywają się według ustalonych zasad:
Na początku statek nr $i$ znajduje się na polu $(x_i, y_i)$, przy czym $x_i$ i $y_i$ to liczby parzyste.
Każdy ze statków skierowany jest w jednym z kierunków – północnym, południowym, wschodnim lub zachodnim.
Bitwa odbywa się w turach.
W każdej turze:
 - Każdy statek przemieszcza się o jedno pole do przodu.
 - Jeśli dwa lub więcej statków znajduje się na tym samym polu, toną i nie uczestniczą dalej w bitwie.

Ruch w każdym z kierunków działa następująco:
- północny (`N`) – zmniejsza współrzędną $y$ o 1
- południowy (`S`)  – zwiększa współrzędną $y$ o 1
- wschodni (`E`) – zwiększa współrzędną $x$ o 1
- zachodni (`W`) – zmniejsza współrzędną $x$ o 1

<br><br><br><br><br><br>

## Wejście
W pierwszej linii wejścia znajduje się liczba naturalna $N$.
Każda z kolejnych $N$ linii zawiera dwie liczby całkowite $x_i$, $y_i$ oraz znak $d_i$, oddzielone spacjami.
Liczby $x_i$ i $y_i$ oznaczają pole startowe statku nr $i$.
Znak $d_i$ to jedna z liter `N`, `S`, `E`, lub `W` – opisuje kierunek $i$-tego statku.

Każdy ze statków zaczyna na innym polu – dla statków o numerach $i$ oraz $j$ (gdzie $i \neq j$) zachodzi $x_i \neq x_j$ lub $y_i \neq y_j$.

## Wyjście
Wypisz numery statków, które przetrwają bitwę.
Numer każdego ze statków wypisz jeden raz, w osobnej linii.
Możesz wypisać numery w dowolnej kolejności.

Jeśli żaden statek nie przetrwa, to wyjście powinno być puste.

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

## Przykłady

### Przykład 1
Wejście:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Wyjście:
```
7
```

Początek bitwy będzie wyglądał następująco:
![](battle-sample1-v2.svg)

Póżniej:
- W drugiej turze, statki o numerach 3 i 4 zderzą się na polu $(4, 4)$.
- W szóstej turze, statki nr 1 i nr 5 zderzą się na $(6, 6)$.
  W tej samej chwili nr 2 i nr 6 zderzą się na $(6, 8)$.
Przetrwa jedynie statek nr 7.

<br>
<br>

### Przykład 2
Wejście:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Wyjście:
```
5
2
```
![](battle-sample2.svg)

W drugiej turze, statki o numerach 1, 3 i 4 zderzą się na polu $(2, 4)$.
Statki o numerach 2 i 5 przetrwają.

<br><br><br><br><br><br>

## Ograniczenia
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (dla $1 \leq i \leq N$); $x_i$ i $y_i$ są parzyste.

## Podzadania
1. (6 punktów) $N = 2$
2. (12 punktów) $N \leq 100$, $x_i, y_i \leq 100$
3. (8 punktów) $N \leq 100$, $x_i, y_i \leq 10^5$
4. (11 punktów) $N \leq 200$
5. (9 punktów) $N \leq 5\,000$
6. (30 punktów) $d_i$ to `S` lub `E`
7. (24 punkty) _brak dodatkowych ograniczeń_
