# Naval battle

Andrei a fost recent promovat la poziția de Mare Amiral al Forțelor Navale din Cehia. Cu toate acestea, când tocmai începuse să creadă că are un loc de muncă stabil, guvernul a anunțat tăieri de buget, inclusiv desfințarea Forțelor Navale.

Așa că Andrei s-a decis să arate guvernului cât de importantă sunt Forțele Navale din Cehia. El știe de la spionii lui despre o viitoare bătălie navală ale celor patru mărețe flote. Dacă ar putea câștiga, va fi suficient să le demonstreze acest fapt.

Din păcate, Forțele Navale din Cehia nu au nici nave de luptă nici porturi. Dar dacă spionii lui Andrei ar captura niște nave ar putea să aibă o șansă. Dacă ar știi el care nave vor rezista bătăliei...

O bătălie navală se desfășoară astfel: Inițial nava $i$ pornește din pătratul $(x_i, y_i)$ unde $x_i$ și $y_i$ sunt pare. În plus, nava aparține uneia dintre cele 4 flote: Nordică, Sudică, Estică sau Vestică. Apoi bătălia se desfășoară în etape. În fiecare etapă:
- Prima oară, fiecare navă se mută simultan cu câte un pătrat în direcția corespunzătoare flotei de care aparține.
- Dacă două sau mai multe nave ocupă același pătrat, se scufundă și dispar de pe hartă.

Bătălia se termina atunci când nu mai este posibil să se scufunde nave. O navă care rezistă bătăliei este o navă care rămâne pe harta după finalul bătăliei.

Navele se mută conform în direcția corespunzătoare flotei din care face parte. Mutarea în fiecare direcție modifică coordonatele navelor astfel:
- Nordic — scade $y$ cu 1
- Sudic — crește $y$ cu 1
- Estic — crește $x$ cu 1
- Vestic — scade $x$ cu 1

## Input
Prima linie din input conține un întreg $N$. Următoarele $N$ linii conțin valorile $x_i$, $y_i$ și $d_i$, separate prin câte un spațiu. Valorile întregi $x_i$ și $y_i$ reprezintă coordonatele navei $i$. $d_i$ este unul dintre caracterele `N`, `S`, `E` or `W`, reprezentând direcția navei $i$.

Nu există două nave cu aceleași coordonate inițiale. Adică, pentru navele $i$ și $j$ ($i \neq j$) fie $x_i \neq x_j$ sau $y_i \neq y_j$.

## Output

Afișați pe câte o linie, numerele de ordine ale fiecărei nave ce rezistă bătăliei.
Puteți afișa numerele în orice ordine.

Dacă nu există astfel de nave, nu se va afișa nimic.

## Exemple

### Exemplul 1
Input:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Output:
```
7
```

Bătălia va arata inițial în felul următor:
![](battle-sample1-v2.svg)

Apoi se desfășoară astfel:
- În timpul celei de-a doua etapă, navele 3 și 4 se ciocnesc la $(4, 4)$.
- În timpul celei de-a patra etapă, navele 1 și 5 se ciocnesc la $(6, 6)$.
  În același timp, 2 și 6 se vor ciocni la $(6, 8)$.
Singura navă care va rezista va fi nava 7.

### Exemplul 2
Input:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Output:
```
5
2
```
![](battle-sample2.svg)

În timpul celei de-a doua etape, navele 1, 3 și 4 se vor ciocni la $(2, 4)$. Navele 2 și 5 vor supraviețui.

## Constraints
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (pentru fiecare $i$ astfel încât $1 \leq i \leq N$) și $x_i, y_i$ sunt pare.

## Subtasks
1. (6 points) $N = 2$
2. (12 points) $N \leq 100$, $x_i, y_i \leq 100$  (pentru fiecare $i$ astfel încât $1 \leq i \leq N$)
3. (8 points) $N \leq 100$, $x_i, y_i \leq 10^5$  (pentru fiecare $i$ astfel încât $1 \leq i \leq N$)
4. (11 points) $N \leq 200$
5. (9 points) $N \leq 5\,000$
6. (30 points) $d_i$ este fie `S` fie `E`  (pentru fiecare $i$ astfel încât $1 \leq i \leq N$)
7. (24 points) _fără restricții suplimentare_
