# Námorná bitka

Merlinovi sa popri štúdiu v Česku náramne darí a nedávno ho vymenovali za veľkoadmirála českých námorných síl.
Keď si však konečne začal myslieť, že má o prácu postarané,
vláda oznámila rozpočtové škrty vrátane rozpustenia jeho flotily.

Merlin nemieni prísť o luxusnú uniformu. Rozhodol sa teda vláde ukázať, aké dôležité je české námorníctvo.
Od svojich špiónov vie o pripravovanej medzinárodnej námornej bitke štyroch veľkých (avšak nemotorných) flotíl.
Ak by sa mu ju podarilo vyhrať, určite by to bola dostatočná ukážka.

Bohužiaľ, české námorníctvo nemá ani vojnové lode, ani námorné prístavy. Ale ak by
Merlinovi špióni ukoristili nejaké lode, mohol by mať šancu.
Keby len vedel, ktoré lode bitku prežijú...

Námorná bitka prebieha nasledovne: Na začiatku sa loď $i$ nachádza na políčku
$(x_i, y_i)$, kde $x_i$ aj $y_i$ sú párne. Okrem toho,
loď patrí do jednej zo štyroch flotíl: Nsevernej, Sjužnej, Evýchodnej alebo Wzápadnej.
Potom bitka prebieha na ťahy. V každom ťahu sa stane nasledovné:
- Najprv sa každá loď súčasne posunie o jedno políčko smerom zodpovedajúcim jej flotile.
- Ak sa v danom ťahu dve alebo viac lodí dostanú na to isté políčko, nastane zrážka, lode sa potopia a zmiznú z mapy.

Bitka skončí, keď už nie je možné, aby nastala ďalšia zrážka. _Preživšia loď_ je taká loď, ktorá ostane na mape po konci bitky.

Lode sa hýbu v smere pohybu svojej flotily.
Pohyb v každom smere mení súradnice lode nasledovne:
- Nseverná - znižuje súradnicu $y$ o 1
- Sjužný - zvyšuje súradnicu $y$ o 1
- Evýchodný - zvyšuje súradnicu $x$ o 1
- Wzápadný - znižuje súradnicu $x$ o 1

## Vstup
Prvý riadok vstupu obsahuje celé číslo $N$. Potom nasleduje $N$ riadkov, každý
obsahuje medzerou oddelené $x_i$, $y_i$ a $d_i$. Celé čísla $x_i$ a $y_i$ sú súradnice $i$-tej lode.
Znak $d_i$ je buď `N`, `S`, `E` alebo `W`, čo opisuje príslušnosť $i$-tej lode do flotily.

Žiadne dve lode nemajú na začiatku rovnaké súradnice.
To znamená, že pre lode $i$ a $j$ ($i \neq j$) platí aspoň jedno z $x_i \neq x_j$, $y_i \neq y_j$.

## Výstup
Pre každú _preživšiu loď_ vypíšte jeden riadok obsahujúci celé číslo
$i$ ($1 \leq i \leq N$) - číslo lode.
Čísla _preživších lodí_ môžete vypisovať v ľubovoľnom poradí.

Ak nie sú žiadne _preživšie lode_, výstup by mal byť prázdny.

## Príklady

### Príklad 1
Vstup:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Výstup:
```
7
```

Bitka bude spočiatku vyzerať takto:
![](battle-sample1-v2.svg)

A potom pokračuje nasledovne:
- Počas 2. ťahu sa lode 3 a 4 zrazia v bode $(4, 4)$.
- Počas 6. ťahu sa lode 1 a 5 zrazia v bode $(6, 6)$.
  V rovnakom čase sa lode 2 a 6 zrazia v bode $(6, 8)$.
Jediná _preživšia loď_ bude loď 7.

### Príklad 2
Vstup:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Výstup:
```
5
2
```
![](battle-sample2.svg)

Po druhom ťahu sa lode 1, 3 a 4 zrazia v bode $(2, 4)$. Lode 2 a 5 prežijú.

## Obmedzenia
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (pre každé $i$ také, že $1 \leq i \leq N$) a $x_i, y_i$ sú párne.

## Podúlohy
1. (6 bodov) $N = 2$
2. (12 bodov) $N \leq 100$, $x_i, y_i \leq 100$ (pre každé $i$ také, že $1 \leq i \leq N$)
3. (8 bodov) $N \leq 100$, $x_i, y_i \leq 10^5$ (pre každé $i$ také, že $1 \leq i \leq N$)
4. (11 bodov) $N \leq 200$
5. (9 bodov) $N \leq 5\,000$
6. (30 bodov) $d_i$ je buď `S` alebo `E` (pre každé $i$ také, že $1 \leq i \leq N$)
7. (24 bodov) _žiadne ďalšie obmedzenia_