# Pomorska bitka

Andreja so pred kratkim povišali v Vrhovnega admirala češke mornarice. Ampak ravno, ko je že začel misliti, da ima varno službo, je vlada naznanila krčenje proračuna in z njim vred razpustitev mornarice. Tako se je Andrej odločil vladi pokazati, kako zelo pomembna je češka mornarica. Najbolje kar tako, da zmaga v kaki pomorski bitki.

Prek svojih vohunov je izvedel za prihajajočo bitko med štirimi sovražnimi flotami. Na žalost češka mornarica nima ne bojnih ladij ne pristanišč, ampak če bi Andrejevim vohunom uspelo prevzeti nadzor nad nekaj sovražnikovimi ladjami, bi mogoče imel možnost zmage. Ko bi le vedel, katere ladje bodo bitko preživele...

V bitki bo udeleženih $N$ ladij, vsaka pripada eni izmed štirih flot: severni, južni, vzhodni ali zahodni. Glede na to pripadnost se premika neprestano v eno smer. Pomorska bitka se potem odvija takole: ladja $i$ začne na celici $(x_i, y_i)$, kjer sta tako $x_i$ kot $y_i$ sodi. Na vsakem koraku bitke se zgodi naslednje:
- Najprej se vse ladje hkrati premaknejo za eno celico v smeri svoje flote.
- Če je po premiku več ladij (dve, tri ali celo 4) na isti celici, se zaletijo, potonejo in izginejo z zemljevida.

Pri plovbi v vsaki smeri se koordinate spreminjajo takole:
- severna (`N` - north) — $y$ koordinata se zmanjša za 1
- južna (`S` - south) — $y$ koordinata se poveča za 1
- vzhodna (`E` - east) — $x$ koordinata se poveča za 1
- zahodna (`W` - west) — $x$ koordinata se zmanjša za 1

Bitke je konec, ko nobeni dve ladji ne moreta več trčiti.
Ladja bitko preživi, če ni bila v nobenem trenutku na isti celici kot katerakoli druga ladja.

## Vhodni podatki
V prvi vrstici vhoda je celo število $N$. Sledi $N$ vrstic, v vsaki so s presledki ločeni $x_i$, $y_i$ in $d_i$.
Celi števili $x_i$ in $y_i$ sta koordinati $i$-te ladje.
Znak $d_i$ je `N`, `S`, `E` ali `W`, in opiše smer $i$-te ladje.

Na začetku na nobeni celici ne pluje več kot ena ladja.
Torej, za ladji $i$ in $j$ ($i \neq j$) velja ali $x_i \neq x_j$ ali $y_i \neq y_j$.

## Izhodni podatki

Izpiši zaporedne številke vseh ladij (med $1$ in $N$), ki niso potonile.
Lahko jih izpišeš v poljubnem vrstnem redu. Če so potonile vse ladje, ne izpiši nič.

## Primeri

### 1. primer
Vhod:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Izhod:
```
7
```

Bitka na začetku izgleda takole:
![](battle-sample1-v2.svg)

Kasneje v bitki:
- Po drugem koraku se bosta zaleteli ladji 3 in 4 v celici $(4, 4)$.
- Po četrtem koraku se bosta zaleteli ladji 1 in 5 v celici $(6, 6)$. Istočasno se v celici $(6, 8)$ zaletita ladji 2 in 6.

Na koncu pluje le še ladja 7, kar tudi izpišeš.

### 2. primer
Vhod:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Izhod:
```
5
2
```
![](battle-sample2.svg)

Po drugem koraku se v celici $(2, 4)$ zaletijo ladje 1, 3 in 4. Ladji 2 in 5 preživita.

<br><br><br><br><br>

## Omejitve
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (za vsak $i$, da $1 \leq i \leq N$) in $x_i, y_i$ sta sodi.

## Podnaloge
1. (6 točk) $N = 2$
2. (12 točk) $N \leq 100$, $x_i, y_i \leq 100$ (za vsak $i$, da $1 \leq i \leq N$)
3. (8 točk) $N \leq 100$, $x_i, y_i \leq 10^5$ (za vsak $i$, da $1 \leq i \leq N$)
4. (11 točk) $N \leq 200$
5. (9 točk) $N \leq 5\,000$
6. (30 točk) $d_i$ je `S` ali `E` (za vsak $i$, da $1 \leq i \leq N$)
7. (24 točk) _brez dodatnih omejitev_
