# Морська битва

Тарас нещодавно був підвищений до звання Гранд-адмірала Військово-морського флоту України. Однак, коли він нарешті почав думати, що має надійну роботу, уряд оголосив про скорочення бюджету, включно із розпуском флоту.

Отже, Тарас вирішив показати уряду, наскільки важливим є Військово-морський флот України. Від своїх шпигунів, він дізнався про майбутню морську битву чотирьох великих флотів. Якщо Тарас зможе виграти її, це стане достатньою демонстрацією важливості флоту.

Якось так сталося, що Військово-морський флот Ураїни не має ні сучасних морських дронів, ні безпечних морських портів. Хоча якщо небайдужі задонатять на кілька морських дронів, у Тараса може з'явитися шанс. Якби ж він тільки знав, які морські дрони уціліють у цій битві...

Морська битва проходить наступним чином: 

Спочатку морьский дрон $i$ починає в квадраті $(x_i, y_i)$, де обидві координати $x_i$ та $y_i$ є парними. Крім того, морський дрон належить одному з чотирьох флотів: Північному, Південному, Східному або Західному. Потім битва проходить по ходах. У кожному ході: 
- Спершу, кожен морьский дрон одночасно рухається на один квадрат у напрямку, що відповідає його флоту.
- Якщо два або більше морських дрони тепер займають один і той же квадрат — вони тонуть і зникають з карти.

Битва закінчується, коли більше неможливо жодного зіткнення. _Уцілівший морський дрон_ — це морський дрон, який залишається на карті після закінчення битви.

Морський дрон рухається згідно з напрямком свого флоту.
Рух у кожному напрямку змінює його координати наступним чином:

- На північ — зменшує координату $y$ на 1
- На південь — збільшує координату $y$ на 1
- На схід — збільшує координату $x$ на 1
- На захід — зменшує координату $x$ на 1

## Формат вхідних даних
Перший рядок вхідних даних містить ціле число $N$. Після чого йде $N$ рядків, кожен з яких містить $x_i$, $y_i$ та $d_i$, які розділені пробілами. Цілі числа $x_i$ та $y_i$ є координатами $i$-го морського дрона. Значення $d_i$ описує напрям $i$-го морського дрона та може приймати значення `N`, `S`, `E` або `W`.

Жодні два морських дрона спочатку не мають однакових координат. Тобто, для морських дронів $i$ та $j$ ($i \neq j$) виконується умова: або $x_i \neq x_j$, або $y_i \neq y_j$.

## Формат вихідних даних
Для кожного _уцілівшого морського дрону_, виведіть окремий рядок, що містить ціле число $i$ ($1 \leq i \leq N$) — номер морського дрона. Ви можете виводити номери _уцілівших морських дронів_ у будь-якому порядку.

Якщо немає _уцілівшого морського дрону_, виведіть порожній рядок.

## Приклади

### Приклад 1
Формат вхідних даних:
```
7
0 6 E
0 8 E
2 4 E
4 2 S
6 0 S
6 2 S
6 4 S
```
Формат вихідних даних:
```
7
```
<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

Початковий стан битви буде виглядати так:
![](battle-sample1-v2.svg)

І подальший розвиток подій виглядатиме наступним чином:
- Під час другого ходу морські дрони 3 і 4 зіткнуться в $(4, 4)$.
- Під час шостого ходу морські дрони 1 і 5 зіткнуться в $(6, 6)$. Так само морські дрони 2 і 6 зіткнуться в $(6, 8)$. Єдиним _уцілівшим морським дроном_ буде номер 7.

### Приклад 2
Формат вхідних даних:
```
5
4 0 S
0 2 E
2 2 E
4 4 N
6 6 W
```
Формат вихідних даних:
```
5
2
```
![](battle-sample2.svg)

Під час другого ходу морські дрони 1, 3 і 4 зіткнуться в $(2, 4)$. Морські дрони 2 і 5 виживуть.

## Обмеження
- $2 \leq N \leq 2 \cdot 10^5$
- $0 \leq x_i, y_i \leq 10^9$ (для кожного $i$ такого, що $1 \leq i \leq N$) та $x_i, y_i$ — парні.

## Підзадача
1. (6 балів) $N = 2$
2. (12 балів) $N \leq 100$, $x_i, y_i \leq 100$ (для кожного $i$ такого, що $1 \leq i \leq N$)
3. (8 балів) $N \leq 100$, $x_i, y_i \leq 10^5$ (для кожного $i$ такого, що $1 \leq i \leq N$)
4. (11 балів) $N \leq 200$
5. (9 балів) $N \leq 5\,000$
6. (30 балів) $d_i$ або `S`, або `E` (для кожного $i$ такого, що $1 \leq i \leq N$)
7. (24 бали) _без додаткових обмежень_
